$fn=100;

zapfkopf_radius=11;
zapfkopf_hoehe=30;

display_hoehe=94;
display_tiefe=10;
display_radius=5;

displayklammer_staerke=4;
displayklammer_breite=30;

// main
union(){
translate([0,display_hoehe/2-0.5,-5]) rotate([-20,0,0]) bracket();
base();
translate([0,20,-8]) rotate([15,0,0]) cube([displayklammer_breite,40,displayklammer_staerke],center=true);
}

// base to mount on keg
module base(){
    union(){
        translate([0,-1*(zapfkopf_hoehe+zapfkopf_radius/2+displayklammer_staerke/2),0]) snapin_klammer();
        translate([0,(zapfkopf_radius+zapfkopf_hoehe)/-2,-zapfkopf_radius-displayklammer_staerke/2]) cube([displayklammer_breite,zapfkopf_hoehe+zapfkopf_radius+displayklammer_staerke,displayklammer_staerke],center=true);
        cube([displayklammer_breite,displayklammer_staerke,2*zapfkopf_radius],center=true);
        translate([0,-displayklammer_staerke/2,-zapfkopf_radius])rotate([45,0,0])cube([displayklammer_breite,1*displayklammer_staerke,1*displayklammer_staerke],center=true);
    }
}
// Snap-In-Klammer
module snapin_klammer(){
    rotate([90,0,0]) difference(){
    cylinder(r=zapfkopf_radius+displayklammer_staerke,h=zapfkopf_radius,center=true);
    cylinder(r=zapfkopf_radius,h=zapfkopf_radius+1,center=true);
    translate([0,1.3*zapfkopf_radius]) cylinder(r=zapfkopf_radius,h=zapfkopf_radius+1,center=true);
    }
}

// Display-Slide-In Bracket
module bracket(){
    difference(){    
        union(){
            cube([displayklammer_breite,display_hoehe,displayklammer_staerke],center=true);
            translate([0,display_hoehe/2,display_tiefe/2+displayklammer_staerke/2]) cube([displayklammer_breite,2*displayklammer_staerke,displayklammer_staerke*2+display_tiefe],center=true);
            translate([0,display_hoehe/-2,display_tiefe/2+displayklammer_staerke/2]) cube([displayklammer_breite,2*displayklammer_staerke,displayklammer_staerke*2+display_tiefe],center=true);
        }
        display_mock();
    }
}

//display mock
module display_mock(){
    translate([0,0,display_tiefe/2+displayklammer_staerke]) union(){
        cube([displayklammer_breite+1,display_hoehe-2*display_radius,display_tiefe],center=true);
        translate([0,(display_hoehe-2*display_radius)/2,0]) rotate([0,90,0]) cylinder(r=display_radius,h=displayklammer_breite+1,center=true);
        translate([0,(display_hoehe-2*display_radius)/-2,0]) rotate([0,90,0]) cylinder(r=display_radius,h=displayklammer_breite+1,center=true);
    }
}